# list of RPMs to be installed as ELTDEV
class eltdev::sysrpms {

  $myrpmlist = [
    # RPMs from ESO-ELT packages
    'elt-ciisrv-alarm-config-gui-devel',
    'elt-ciisrv-client-api-devel',
    'elt-ciisrv-common',
    'elt-ciisrv-config-gui-devel',
    'elt-ciisrv-config-ng-devel',
    'elt-ciisrv-config-tools',
    'elt-ciisrv-error-indexer',
    'elt-ciisrv-ias-bridge',
    'elt-ciisrv-log-gui',
    'elt-ciisrv-oldb-client-devel',
    'elt-ciisrv-oldb-gui-devel',
    'elt-ciisrv-postinstall',
    'elt-ciisrv-qt-widgets-devel',
    'elt-ciisrv-robot-library',
    'elt-ciisrv-srv-config',
    'elt-ciisrv-srv-oldb',
    'elt-ciisrv-srv-telemetry-devel',
    'elt-ciisrv-tooling',
    'elt-common-system',
    'elt-common-tools',
    'elt-cut-devel',
    'elt-ecsif-devel',
    'elt-etr',
    'elt-etr-doc',
    'elt-mal-devel',
    'elt-msgsend',
    'elt-mudpi-devel',
    'elt-oldbloader',
    'elt-rtms-devel',
    'elt-taiclock-devel',
    'elt-trs-common-devel',
    'elt-wtools',
    'eso-fits-tools',
    'puppet-time',
    'python3-sphinx-eso-theme',
    'python3-spyder-esobin',

    # RPMs from third software components packaged at ESO:
    'aravis-0.8-devel',
    'aws-sdk-cpp-devel',
    'azmq-devel',
    'beust-jcommander-wdep',
    'boost-cli-devel',
    'bumpversion',
    'cext-devel',
    'checkstyle',
    'checkstyle-wdep',
    'consul',
    'cpl-devel',
    'cpl-devel-pc',
    'cpp-netlib-uri',
    #'elasticsearch', # see below
    'ds9',
    'fast-cdr',
    'fast-dds',
    'fast-dds-gen',
    'fast-dds-monitor',
    'fast-dds-statistics-backend',
    'filebeat',
    'fitsverify',
    'foonathan-memory-vendor',
    'fv',
    'guidelines-support-library-pc',
    'jaeger',
    'kibana',
    'kibana-logtrail',
    'libbacktrace-devel',
    'libppconsul-devel',
    'libskyr-url',
    #'logstash', # see below
    'minio',
    'mcli',
    'nix',
    'nomad',
    'open62541-devel',
    'openblas-devel-pc',
    'protobuf-java-wdep',
    'puppet-wait_for',
    'pybind11-devel-pc',
    'python3-aioredis',
    'python3-asyncclick',
    'python3-asyncua',
    'python3-consul2',
    'python3-docstring-parser',
    'python3-doxypypy',
    'python3-elasticsearch',
    'python3-guidata',
    'python3-guiqwt',
    'python3-hashids',
    'python3-hsluv',
    'python3-minimalmodbus',
    'python3-nomad',
    'python3-pytest-custom_exit_code',
    'python3-pytest-qt',
    'python3-sphinxcontrib-plantuml',
    'python3-qwt',
    'python3-robotframework',
    'python3-robotframework-redislibrary',
    'python3-taurus',
    'python3-taurus-pyqtgraph',
    'python3-vispy',
    'qtopcua',
    'redis-plus-plus-devel',
    'rt-pc',
    'testng-wdep',
    'waf',
    'wdep',
    'wireshark-mudpi-dissector',
    'wireshark-rtms-dissector',
    'wireshark-zmtp-dissector',
    'zeromq-devel',

    # RPMs provided with Fedora distribution:
    'annobin-annocheck',
    'assimp',
    'astropy-tools',
    'attr',
    'autofs',
    'bash-completion',
    'bc',
    'bind-utils',
    'binutils',
    'black',
    'boost-devel',
    'boost-json',
    'boost-static',
    'bzip2',
    'catch-devel',
    'CCfits-devel',
    'chkconfig',
    'chrony',
    'cifs-utils',
    'clang-tools-extra',
    'cli11-devel',
    'cloc',
    'cppcheck',
    'cppzmq-devel',
    'cronie',
    'crontabs',
    'ctags',
    'czmq-devel',
    'date-devel',
    'device-mapper-multipath',
    'dnf-utils',
    'dosfstools',
    'dotconf',
    'doxygen',
    'dpdk-devel',
    'drpm',
    'dyninst',
    'eclipse-cdt',
    'eclipse-cdt-qt',
    'eclipse-jdt',
    'eclipse-jgit',
    'eclipse-pydev',
    'elfutils',
    'emacs',
    'emacs-nox',
    'eog',
    'erfa-devel',
    'espeak-ng',
    'ethtool',
    'evince',
    'fftw-devel',
    'findbugs',
    'firefox',
    'fmt-devel',
    'fuse',
    'gammaray-qt5',
    'gcc',
    'gcc-c++',
    'gcovr',
    'gdb',
    'gdb-doc',
    'gdb-gdbserver',
    'gdbm',
    'geany',
    'git',
    'gitg',
    'git-gui',
    'git-lfs',
    'gitlint',
    'git-svn',
    'glib2-devel',
    'glibc-static',
    'gmock',
    'gmock-devel',
    'gmp-devel',  # TODO TREx dependency, review with ELT DevEnv 5
    'gnuplot',
    'gnuradio-devel',  # TODO TREx dependency, review with ELT DevEnv 5
    'google-benchmark-devel',
    'gperftools',
    'gstreamer1',
    'gstreamer1-plugins-bad-free',
    'gstreamer1-plugins-good',
    'gstreamer1-plugins-ugly-free',
    'gtest',
    'gtest-devel',
    'guidelines-support-library-devel',
    'hdf5-devel',
    'hiredis-devel',
    'htop',
    'hwloc',
    'hwloc-gui',
    'ImageMagick',
    'iftop',
    'iio-sensor-proxy',
    'iotop',
    'iperf3',
    'iproute-tc',
    'irrXML',
    'jacoco',
    'jacoco-wdep',
    'java-1.8.0-openjdk-devel',
    'java-1.8.0-openjdk-javadoc',
    'java-1.8.0-openjdk-src',
    'json-devel',
    'jq',
    'kernel',
    'kernel-debug-devel',
    'kernel-modules-extra',
    'kernel-tools',
    'kernel-tools-libs',
    'latex-eso-pdm-style',
    'latexmk',
    'libao',
    'libasan',
    'libatomic',
    'libcgroup-devel',
    'libcgroup-tools',
    'libcom_err-devel',
    'libcurl-devel',
    'libdate-tz',
    'liblsan',
    'libmng',
    'libnsl2-devel',
    'libpcap-devel',
    'libpciaccess-devel',
    'libsodium-devel',
    'libstdc++-docs',
    'libstdc++-static',
    'libtsan',
    'libubsan',
    'libusb-devel',
    'libuuid-devel',
    'libverto-devel',
    'libX11-devel',
    'libxml2-devel',
    'libXScrnSaver',
    'libxslt',
    'libXtst-devel',
    'libzstd-devel',
    'lightdm',
    'lightdm-gtk',
    'linuxptp',
    'llvm',
    'lm_sensors-devel',
    'Lmod',
    'log4cplus-devel',
    'log4cpp-devel',  # TODO TREx dependency, review with ELT DevEnv 5
    'lshw',
    'lsof',
    'ltrace',
    'lz4-devel',
    'man-pages',
    'mbedtls',
    'mc',
    'mcelog',
    'meld',
    'mesa-libGL-devel',
    'minizip-compat',
    'mlocate',
    'mousepad',
    'mpir-devel',  # TODO TREx dependency, review with ELT DevEnv 5
    'nano',
    'ncurses-devel',
    'netsniff-ng',
    'net-snmp',
    'net-snmp-devel',
    'net-snmp-utils',
    'network-manager-applet',
    'NetworkManager-tui',
    'nfs-utils',
    'nmap-ncat',
    'numactl',
    'numactl-devel',
    'octave',
    'oddjob-mkhomedir',
    'omping',
    'openblas-devel',
    'opentelemetry-cpp-devel',
    'open-vm-tools-desktop',
    'pcaudiolib',
    'perf',
    'pipewire',
    'pkgconf',
    'plantuml',
    'poly2tri',
    'protobuf-devel',
    'protobuf-java',
    'pybind11-devel',
    'pylint',
    'pyside2-tools',
    'python-mako-doc',
    'python3-anyio',
    'python3-astropy',
    'python3-boto3',
    'python3-breathe',
    'python3-colorama',
    'python3-cookiecutter',
    'python3-flask',
    'python3-freetype',
    'python3-gobject',
    'python3-h5py',
    'python3-inotify',
    'python3-ipdb',
    'python3-ipywidgets',
    'python3-jep',
    'python3-jsonref',
    'python3-jsonschema',
    'python3-kiwisolver',
    'python3-mako',
    'python3-matplotlib',
    'python3-mock',
    'python3-networkx',
    'python3-nose',
    'python3-notebook',
    'python3-openpyxl',
    'python3-pandas',
    'python3-protobuf',
    'python3-psutil',
    'python3-pyasn1',
    'python3-pybind11',
    'python3-pylint',
    'python3-pyserial',
    'python3-pyserial-asyncio',
    'python3-pyside2-devel',
    'python3-pyyaml',
    'python3-redis',
    'python3-shiboken2',
    'python3-smi',
    'python3-spyder',
    'python3-sphinx',
    'python3-trollius',
    'python3-xmlrunner',
    'python3-zmq',
    'python3-zope-interface',
    'qt-creator',
    'qt5-linguist',
    'qt5-qt3d',
    'qt5-qtbase-devel',
    'qt5-qtcharts',
    'qt5-qtdatavis3d',
    'qt5-qtgraphicaleffects',
    'qt5-qtimageformats',
    'qt5-qtlocation',
    'qt5-qtquickcontrols2',
    'qt5-qtremoteobjects',
    'qt5-qtscript',
    'qt5-qtscxml',
    'qt5-qtsensors',
    'qt5-qtserialport',
    'qt5-qtspeech',
    'qt5-qtspeech-speechd',
    'qt5-qtsvg-devel',
    'qt5-qttools-common',
    'qt5-qttools-devel',
    'qt5-qttools-libs-designer',
    'qt5-qttools-libs-designercomponents',
    'qt5-qttools-libs-help',
    'qt5-qtwebchannel',
    'qt5-qtwebengine',
    'qt5-qtwebsockets',
    'qt5-qtxmlpatterns',
    'qwt5-qt5-devel',
    're2',
    'realmd',
    'redis',
    'rpm-build',
    'rsync',
    'rsyslog',
    'rubygem-puppet-lint',
    'rubygem-puppet-lint-doc',
    'samba-client',
    'screen',
    'shiboken2',
    'snappy',
    'spdlog-devel',
    'speech-dispatcher',
    'speech-dispatcher-espeak-ng',
    'sssd-ad',
    'sssd-krb5',
    'sssd-ldap',
    'strace',
    'swig',
    'sysstat',
    'systemtap',
    'tcpdump',
    'texlive-capt-of',
    'texlive-comment',
    'texlive-draftwatermark',
    'texlive-epstopdf',
    'texlive-everypage',
    'texlive-fncychap',
    'texlive-framed',
    'texlive-needspace',
    'texlive-plantuml',
    'texlive-tabulary',
    'texlive-ulem',
    'texlive-upquote',
    'texlive-wrapfig',
    'telnet',
    'testng',
    'tigervnc',
    'tigervnc-server',
    'time',
    'tmux',
    'traceroute',
    'tree',
    'usbutils',
    'valgrind-devel',
    'vim-enhanced',
    'virt-what',
    'wcslib-devel',
    'wireshark',
    'xerces-c-devel',
    'xfce4-about',
    'xfce4-appfinder',
    'xfce4-notifyd',
    'xfce4-pulseaudio-plugin',
    'xfce4-screenshooter',
    'xfce4-session',
    'xfce4-settings',
    'xfce4-taskmanager',
    'xfce4-terminal',
    'xfce4-whiskermenu-plugin',
    'xfdesktop',
    'xfwm4',
    'xorg-x11-server-Xorg',
    'xorg-x11-server-Xvfb',
    'yaml-cpp-devel',
    'yp-tools',
  ]

  # elasticsearch and logstash depends on java (in $myrpmlist) being installed first
  package { ['elasticsearch', 'logstash']:
    ensure  => 'installed',
  }


  if $::fast_yum_install == 'YES' {
    # Puppet is extremely slow on single RPM, this is a shortcut just for first installation
    $pkglist = join($myrpmlist,' ')
    exec { 'cmdline_yum':
      command => "/usr/bin/dnf -y install ${pkglist}",
      timeout => 0,
      require => Augeas['selinux'],
    }

    # Add explicit ordering for Java dependant RPMs
    Package['elasticsearch', 'logstash'] { require => Exec['cmdline_yum'] }
  } else {
    package { $myrpmlist:
      ensure => 'installed',
    }

    # Add explicit ordering for Java dependant RPMs
    Package['elasticsearch', 'logstash'] { require => Package[$myrpmlist] }
  }
}
